//
//
// Common functions for Object DLL capabilities
// C. Beaudet
//

#include "stdafx.h"
#include "afxdllx.h"
#include "ACP_Base.h"
#include "itf.h"
#include "inctex.h"
#include "_interf.hpp"
#include "x:\cpa\main\inc\_editid.h"


//------------------------------------------------------------------------
// Global vars
static char                         *gs_p_szCPAVersion = C_szCPAVersion;
static AFX_EXTENSION_MODULE NEAR    extensionDLL = { NULL, NULL };

#ifdef DLL_ONLY_ONE_INSTANCE
Material_Interface *gs_p_oMaterialInterface = NULL;
#endif

static CList<CPA_DLLBase*,CPA_DLLBase*> g_oListOfInstances;	//private internal

//------------------------------------------------------------------------
// functions that are present in all DLL :
//------------------------------------------------------------------------

//========================================================================
// Get current CPA version
//========================================================================
extern "C" char __declspec(dllexport) *fn_p_szGetCPAVersion(void)
{
    return gs_p_szCPAVersion;
}

//========================================================================
// Get type of this DLL
//========================================================================
extern "C" tdstDLLIdentity __declspec(dllexport) *fn_p_stGetDLLIdentity(void)
{
    g_stMaterialIdentity . eType              = TOOL_DLL;
    g_stMaterialIdentity . csName             = C_szDLLMaterialName;
    g_stMaterialIdentity . hModule            = NULL;
    g_stMaterialIdentity . p_oListOfInstances = &g_oListOfInstances;

    return &g_stMaterialIdentity;
}

//========================================================================
// DLL int function
//========================================================================
extern "C" void __declspec(dllexport) fn_vInitDll(void)
{
	new CDynLinkLibrary(extensionDLL);
}

//========================================================================
// DLL entry point
//========================================================================
extern "C" int __stdcall DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		if (!AfxInitExtensionModule(extensionDLL, hInstance))
		   return 0;
	}
	return 1;
}

//========================================================================
// Get the DLL
//========================================================================
extern "C" CPA_DLLBase __declspec(dllexport) *fn_p_oGetDLL(long lKey)
{
#ifdef DLL_ONLY_ONE_INSTANCE

	switch(lKey)
	{
	case 0:	// the game world
		if (gs_p_oMaterialInterface == NULL)
		{
			//when the material editor is loaded, the tree of loaded texture names must not be reinitialized
			//GLI_vReinitTreeOfTextureNameSwitch(FALSE);
			gs_p_oMaterialInterface = new Material_Interface();
			ASSERT(gs_p_oMaterialInterface != NULL);
		}
		return gs_p_oMaterialInterface;
		break;

	default:
		return NULL;
	}

#else //DLL_ONLY_ONE_INSTANCE

	switch(lKey)
	{
	case 0:	// the game world
        return new Material_Interface();
		break;

	default:
		return NULL;
	}

#endif //DLL_ONLY_ONE_INSTANCE
}


//------------------------------------------------------------------------
// functions that are present in this type of DLL only :
//------------------------------------------------------------------------

#undef DLL_ONLY_ONE_INSTANCE
